#DEFINE WIN32_LEAN_AND_MEAN
#DEFINE LINKFILES
#include <windows.h>
#include <commctrl.h>
const section
IDM_CREATE_THREAD 	equ	10002
IDM_EXIT 			equ	10003
WM_FINISH			equ	WM_USER+100h

// ================================================================ 
// GoRC /r, res\multithreading15.rc
// GoAsm multithreading15.asm
// GoLink multithreading15.obj res\multithreading15.res user32.dll kernel32.dll
// ================================================================
ID_DOGIM = 6000

code section

Start:
  	invoke GetModuleHandle,0							; Retrieves a module handle for the specified module. INVOKE
    mov [wc.hInstance],eax								; save it in member of WNDCLASSEX
    invoke GetCommandLine								; Retrieves the command-line string for the current process.
	mov [CommandLine],eax								; save the pointer to the command-line string for the current process.
	invoke InitCommonControls							; Registers and initializes certain common control window classes.
    invoke LoadIcon,[wc.hInstance],6000					; Loads the specified icon resource from the executable (.exe)
    mov [wc.hIcon],eax									; save handle to the newly loaded icon.
    invoke LoadCursor,0,IDC_ARROW						; Loads the specified cursor resource from the executable (.EXE)
    mov [wc.hCursor],eax								; handle to the newly loaded cursor.
    invoke GetSystemMetrics,SM_CXSCREEN					; The width of the screen of the primary display monitor, in pixels.
    sub eax,[Win_Width]									; SM_CXSCREEN - [Win_Width]
    shr eax,1											; (SM_CXSCREEN-[Win_Width])/2
    mov [Wind_X],eax									; save calculated X into var
    invoke GetSystemMetrics,SM_CYSCREEN					; The height of the screen of the primary display monitor, in pixels.
    sub eax,[Win_Height]								; SM_CYSCREEN - [Win_Height]
    shr eax,1											; (SM_CYSCREEN-[Win_Height])/2
    mov [Wind_H],eax									; save calculated Y into var
    invoke RegisterClassEx,addr wc						; Registers a window class for subsequent use in calls to the CreateWindow or CreateWindowEx function. 
    invoke CreateWindowEx,\								; Creates an overlapped, pop-up, or child window with an extended window style;
    			WS_EX_CLIENTEDGE,\						; DWORD dwExStyle
    			addr ClassName,\						; LPCTSTR lpClassName
    			addr Title,\							; LPCTSTR lpWindowName
                WS_OVERLAPPEDWINDOW+WS_VISIBLE,\		; DWORD dwStyle
                [Wind_X],\								; int x The initial horizontal position of the window.
                [Wind_H],\								; int x The initial vertical position of the window.
                [Win_Width],\							; int nWidth The width, in device units, of the window. 	
                [Win_Height],\							; int nHeight The height, in device units, of the window.
                0,\										; HWND hWndParent A handle to the parent or owner window of the window being created.
                0,\										; HMENU hMenu A handle to a menu, or specifies a child-window identifier, depending on the window style.
                [wc.hInstance],\						; HINSTANCE hInstance A handle to the instance of the module to be associated with the window.
                0										; LPVOID lpParam
    mov [hWnd],eax										; Save the return value is a handle to the new window.
    
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT				; Sets the specified window's show state
    invoke UpdateWindow,[hWnd]							; updates the client area of the specified window ( sends 1st WM_PAINT )

MessageLoop:
    invoke GetMessage,addr msg,0,0,0					; Retrieves a message from the calling thread's message queue
    or eax,eax
    jz >ExitProgram
    invoke TranslateMessage,addr msg
    invoke DispatchMessage, addr  msg
    jmp <MessageLoop
ExitProgram:
	int 3
    invoke ExitProcess,[msg.wParam]


WindowProc FRAME  hWnd, uMsg, wParam, lParam
    uses ebx, esi, edi
.wmclose
    cmp D[uMsg],WM_CLOSE
    jne >.wmcommand
    invoke MessageBox,[hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION
    invoke PostQuitMessage,0
    jmp >>.exit

.wmcommand
	cmp	D[uMsg],WM_COMMAND
	jne >.wmfinish
	mov	eax,[wParam]
	cmp	d[lParam],0
	jne >>.exit
	cmp ax,IDM_CREATE_THREAD
	jne	>>.kill_and_exit
	mov	eax, OFFSET ThreadProc
	invoke	CreateThread,\								; Creates a thread to execute within the virtual address space of the calling process.	 
					NULL,\								; A pointer to a SECURITY_ATTRIBUTES structure
					NULL,\								; If this parameter is zero, the new thread uses the default size for the executable
					eax,\								; A pointer to the application-defined function to be executed by the thread.
					NULL,\								; A pointer to a variable to be passed to the thread.
					NORMAL_PRIORITY_CLASS,\				; The flags that control the creation of the thread.
					ADDR ThreadID						; A pointer to a variable that receives the thread identifier
	invoke 	CloseHandle,eax
	jmp >.exit	
	
.wmfinish
	cmp	D[uMsg],WM_FINISH
	jne	>>.defwindowproc
	invoke	MessageBoxEx,NULL,ADDR szMbString,ADDR szAppName,MB_OK,0
	jmp	>.exit
	

.kill_and_exit		
	invoke DestroyWindow,[hWnd]
	jmp	>.exit


.defwindowproc:
    invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]
    ret
.exit:
    xor eax,eax
    ret
ENDF


    
ThreadProc FRAME Param
uses ecx
	mov	ecx,600000000
Loop1:
	add eax,eax
	dec ecx
	jz	> exit_loop
	jmp	Loop1
exit_loop:
	invoke	PostMessage,[hWnd],WM_FINISH,NULL,NULL
	ret
ENDF		

data	section

  Title     	db ' Multithreading15 version 1.0 programmed in Goasm',0
  ClassName 	db ' Multithreading15 class',0
  MsgEnd    	db ' End of program multithreading15 !!Goasm!! ',0
  szAppName		db ' Message',0
  szMbString	db ' Calculations is complete',0
  align 4
  Wind_X      	dd 0
  Wind_H      	dd 0
  Win_Width      	dd 512
  Win_Height      	dd 352
  hWnd      	dd ?
  CommandLine	dd ?
  ThreadID		dd ?
  
  wc        WNDCLASSEX  <	sizeof (WNDCLASSEX),\	;	cbSize
											0,\		;	style
							  addr WindowProc,\		;	lpfnWndProc
											0,\		;	lpfnWndProc
											0,\		;	cbWndExtra
										 NULL,\		;	hInstance
										 NULL,\		;	hIcon
										 NULL,\		;	hCursor
							   COLOR_WINDOW+1,\		;	hbrBackground
							            10000,\		;	lpszMenuName
							   addr ClassName,\		;	lpszClassName
										 NULL>		;	hIconSm
msg       MSG <>										 
										 
